#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"
#include "UsersGuid.h"

unsigned int PORTD = 0x0100;
//int m = 0;
//int n = 0;

void mytask1(void *pvParameters){
	xSemaphoreHandle mtx = *(xSemaphoreHandle *)pvParameters;
	while(1){				// Takeできないときの待ち時間は0
		if( xSemaphoreTake( mtx, ( portTickType ) 0 ) == pdTRUE ){
			PORTD ^= 0x01;
			PUT_UINT32(0xA0000000, PORTD);
			xSemaphoreGive( mtx );
		}else{
			PORTD ^= 0x10;
			PUT_UINT32(0xa0000000, PORTD);
		}
		vTaskDelay(500 / portTICK_RATE_MS);
	}
}

void mytask2(void *pvParameters)
{
	int x;
	xSemaphoreHandle mtx = *(xSemaphoreHandle*)pvParameters;
	while(1){
		if( xSemaphoreTake( mtx, ( portTickType ) 0 ) == pdTRUE ){
			PORTD ^= 0x02;
			PUT_UINT32(0xA0000000, PORTD);
			do{
				x = ~GET_UINT32(0xa0000000) & 0x03;
			}while(x);	// ボタンSWが押されるとループ

			xSemaphoreGive( mtx );
		}else{
			PORTD ^= 0x20;
			PUT_UINT32(0xa0000000, PORTD);
		}
		vTaskDelay(800 / portTICK_RATE_MS);
	}
}
extern volatile void * volatile pxCurrentTCB;							\

int main()
{
	xSemaphoreHandle mtx;

	mtx  = xSemaphoreCreateMutex();		// mutex作成
										// 各タスクに mutex を渡す
	xTaskCreate( mytask1, (signed portCHAR *)"T1", 100, &mtx, 1, NULL);
	xTaskCreate( mytask2, (signed portCHAR *)"T2", 100, &mtx, 1, NULL);

	vTaskStartScheduler();
	while(1);
}
